6.121   os16: strtol(3)

NOME

    strtol, strtoul - conversione di una stringa in un numero

SINTASSI

    #include <stdlib.h>
    long int strtol (const char *restrict <string>, char **restrict <endptr>,
                     int <base>);

    unsigned long int strtoul (const char *restrict <string>,
                               char **restrict <endptr>, int <base>);

DESCRIZIONE

    Le funzioni <strtol()> e <strtoul()>, convertono la stringa <string> in un
    numero, intendendo la sequenza di caratteri nella base di numerazione
    indicata come ultimo argomento (<base>). Tuttavia, la base di numerazione
    potrebbe essere omessa (valore zero) e in tal caso la stringa deve essere
    interpretata ugualmente in qualche modo: se (dopo un segno eventuale)
    inizia con zero seguito da un'altra cifra numerica, deve trattarsi di una
    sequenza ottale; se inizia con zero, quindi appare una lettera "x" deve
    trattarsi di un numero esadecimale; se inizia con una cifra numerica
    diversa da zero, deve trattarsi di un numero in base dieci.

    La traduzione della stringa ha luogo progressivamente, arrestandosi quando
    si incontra un carattere incompatibile con la base di numerazione
    selezionata o stabilita automaticamente. Il valore convertito viene
    restituito; inoltre, se il puntatore <endptr> e` valido (diverso da NULL),
    si assegna a <*endptr> la posizione raggiunta nella stringa, corrispondente
    al primo carattere che non puo` essere convertito. Pertanto, nello stesso
    modo, se la stringa non puo` essere convertita affatto e si puo` assegnare
    qualcosa a <*endptr>, alla fine, <*endptr> corrisponde esattamente a
    <string>.

VALORE RESTITUITO

    Le funzioni restituiscono il valore tratto dall'interpretazione della
    stringa, ammesso che sia rappresentabile, altrimenti si ottiene LONG_MIN o
    LONG_MAX, a seconda dei casi, sapendo che occorre consultare la variabile
    <errno> per maggiori dettagli.

ERRORI

    Valore
    di      Significato
    <errno>
    EINVAL  Argomento non valido.

    ERANGE  Il valore risultante e` al di fuori dell'intervallo ammissibile per
            la rappresentazione.

DIFETTI

    La realizzazione di <strtoul()> e` incompleta, in quanto si limita a
    utilizzare <strtol()>, convertendo il risultato in un valore senza segno.

FILE SORGENTI

    lib/stdlib.h [13.10]

    lib/stdlib/strtol.c [13.10.18]

    lib/stdlib/strtoul.c [13.10.19]

